#ifndef MYSTICREALMS_H
#define MYSTICREALMS_H



/* **********************************************************************************************************************
   Included Header Files
   **********************************************************************************************************************/

//#include "../VDEngine/VDWindow.h"
#include "../VDEngine/VDDirect3D.h"
#include "../VDEngine/VDInput.h"
#include "../VDEngine/VDWorld.h"
#include "../VDEngine/VDPlayer.h"
#include <time.h>



/* **********************************************************************************************************************
   Linked Libraries
   **********************************************************************************************************************/

//#pragma comment(lib, "VDEngine.lib")



/* **********************************************************************************************************************
   MysticRealms
   **********************************************************************************************************************/

class MysticRealms {
public:
    MysticRealms(); 
    ~MysticRealms();

    void Run(HINSTANCE instance);
    void UpdateGame(double currentTime);
    void LoadNPCs();
    void LoadObjects();
private:
    typedef enum GameState {
        VD_TITLE,
        VD_GAMEWORLD,
        VD_GAMEBATTLE,
        VD_EXIT
    };
    enum KeyChoice {
        VD_NONE,
        VD_UP,
        VD_DOWN,
        VD_LEFT,
        VD_RIGHT,
        VD_ESCAPE
    };

           BOOL gameRunning;
      HWND window;
    VDDirect3D* graphics;
       VDInput* input;
       VDWorld* world;
      VDPlayer* player;
            int width, height;
        __int64 highResolutionPerformanceCount;
        __int64 highResolutionPerformanceCounterFrequency;
         double gameUpdateCount;
         double currentTime;
      GameState gameState;
           BOOL enteringNewArea;

       vector<VDNPC> npcs;
    vector<VDEntity> objects;
};



#endif  // MYSTICREALMS_H