/* **********************************************************************************************************************
   Included Header Files
   **********************************************************************************************************************/

#include "VDCreatureEditor.h"



/* **********************************************************************************************************************
   Constructor
   **********************************************************************************************************************/

VDCreatureEditor::VDCreatureEditor() {
};



/* **********************************************************************************************************************
   Destructor
   **********************************************************************************************************************/

VDCreatureEditor::~VDCreatureEditor() {
    if (window != NULL) {
        (void) DestroyWindow(window);
        window = NULL;
    };
};



HWND VDCreatureEditor::Load(HINSTANCE instance, HWND parentWindow, LPCSTR className) {
    // create the window
    RECT windowDimensions;
    (void) GetWindowRect(parentWindow, &windowDimensions);
    window = CreateWindowEx(WS_EX_TOPMOST | WS_EX_TOOLWINDOW,      // extended window styles
                            className,                             // class name
                            "Creature Editor",                     // window name
                            WS_CAPTION | WS_SYSMENU | WS_VISIBLE,  // window styles
                            windowDimensions.left + 100,           // x coordinate (0 = left)
                            windowDimensions.top + 100,            // y coordinate (0 = top)
                            200,                                   // width
                            200,                                   // height
                            NULL,                                  // parent/owner window
                            NULL,                                  // menu
                            instance,                              // instance
                            NULL);                                 // used for CREATESTRUCT structure
    if (window == NULL) {
        VDError("Failed to create the map editor window.", __FILE__, __LINE__);
    };

    return window;
};