#ifndef VDENGINE_H
#define VDENGINE_H



/* **********************************************************************************************************************
   Included Header Files
   **********************************************************************************************************************/

#include "VDMapEditor.h"
#include "VDNPCEditor.h"
#include "VDObjectEditor.h"
#include "VDItemEditor.h"
#include "VDCreatureEditor.h"
#include "VDDirect3D.h"
#include "VDInput.h"
#include "VDWorld.h"
#include "VDEntity.h"
#include "VDNPC.h"
#include "Resource.h"
#include "VDDialogue.h"
#include "../MysticRealms/MysticRealms.h"



/* **********************************************************************************************************************
   VDEngine
   **********************************************************************************************************************/

class VDEngine {
public:
    VDEngine();
    virtual ~VDEngine();

    void Run(HINSTANCE instance);
    void RegisterWindows(HINSTANCE instance);
    void ProcessMenu(HINSTANCE instance, MSG message);
    void OpenMap();
    void ClearMap();
    void SaveMap();
    void ProcessWorldEditing();
    void VDSaveFile(HWND window, LPSTR filter, LPSTR fileName);
    void LoadNPCs();
    void LoadObjects();

    VDNPC* GetNPC(LPCSTR name);
private:
                 BOOL vdEngineRunning;
         VDMapEditor* mapEditor;
         VDNPCEditor* npcEditor;
      VDObjectEditor* objectEditor;
        VDItemEditor* itemEditor;
    VDCreatureEditor* creatureEditor;
          VDDirect3D* graphics;
             VDInput* input;
             VDWorld* world;
            VDEntity* user;
            VDEntity* worldOffset;
        vector<VDNPC> npcs;
     vector<VDEntity> objects;
       vector<VDItem> items;
                  int width, height;
                POINT actualMousePosition;
};



#endif  // VDENGINE_H