#ifndef VDITEMEDITOR_H
#define VDITEMEDITOR_H



/* **********************************************************************************************************************
   Included Header Files
   **********************************************************************************************************************/

#include <windows.h>
#include <vector>
#include "VDItem.h"
#include "VDError.h"
#include "VDSprite.h"
#include "VDInput.h"
#include "Resource.h"
using namespace std;



/* **********************************************************************************************************************
   VDItemEditor
   **********************************************************************************************************************/

class VDItemEditor {
public:
    VDItemEditor();
    ~VDItemEditor();

    void FreeMemory();
    HWND Load(HINSTANCE instance, HWND parentWindow, LPCSTR className);
    void ProcessMessages(HINSTANCE instance, LPDIRECT3DDEVICE9 direct3DDevice, VDInput* input, vector<VDItem>* items);
    void ResetWindow();
    BOOL AddItem(vector<VDItem>* items, LPCSTR name, LPCSTR imageFileLocation);
    void CreateItemTexture(LPDIRECT3DDEVICE9 direct3DDevice, VDSprite* sprite, LPCSTR npcFileName);
    void WriteItems(vector<VDItem>* items);

    VDItem* GetVDItem(vector<VDItem>* items, LPCSTR name);

         HWND GetWindow()                   { return window; }
         HWND GetItemListBox()              { return itemListBox; }
    VDSprite* GetItemSprite()               { return itemSprite; }
       LPRECT GetItemSpriteDimensions()     { return &itemSpriteDimensions; }
         BOOL GetReloadItems()              { return reloadItems; }
         void SetReloadItems(BOOL reload)   { reloadItems = reload; }
private:
         HWND window;
         HWND itemListBox;
         char currentItemSelection[FILE_NAME_MAX_SIZE];
    VDSprite* itemSprite;
         char itemSpriteImageLocation[FILE_NAME_MAX_SIZE];
         RECT itemSpriteDimensions;
         BOOL itemSelected;
         HWND removeItemButton;
         HWND transparencyColor;
         HWND loadSpriteButton;
         HWND shiftSpriteUpButton;
         HWND shiftSpriteDownButton;
         HWND shiftSpriteLeftButton;
         HWND shiftSpriteRightButton;
         HWND nameEditBox;
         HWND usableOption;
         HWND armorOption;
         HWND weaponOption;
         HWND accessoryOption;
         HWND questOption;
          int currentItemTypeIndex;

         HWND armorLocationStatic;
         HWND locationHeadCheckBox;
         HWND locationEyesCheckBox;
         HWND locationNeckCheckBox;
         HWND locationShouldersCheckBox;
         HWND locationChestCheckBox;
         HWND locationBackCheckBox;
         HWND locationAbdomenCheckBox;
         HWND locationArmsCheckBox;
         HWND locationHandsCheckBox;
         HWND locationLegsCheckBox;
         HWND locationFeetCheckBox;
         HWND protectionStatic;
         HWND protectionEditBox;
         HWND protectionLevelStatic;

         HWND itemTypeComboBox;
         char currentItemTypeSelection[FILE_NAME_MAX_SIZE];
         HWND armorLocationComboBox;
         HWND armorProtectionStatic;
         HWND armorProtectionComboBox;

         HWND addItemButton;
         HWND saveChangesButton;
         BOOL reloadItems;
};



#endif  // VDITEMEDITOR_H