#ifndef VDMAPEDITOR_H
#define VDMAPEDITOR_H



/* **********************************************************************************************************************
   Included Header Files
   **********************************************************************************************************************/

#include <windows.h>
#include "VDSprite.h"
#include "VDInput.h"
#include "VDNPC.h"
#include "VDError.h"
#include "Resource.h"



/* **********************************************************************************************************************
   VDMapEditor
   **********************************************************************************************************************/

class VDMapEditor {
public:
    VDMapEditor();
    ~VDMapEditor();

    void FreeMemory();
    HWND Load(HINSTANCE instance, HWND parentWindow, LPCSTR className);
    void ProcessMessages(LPDIRECT3DDEVICE9 direct3DDevice, VDInput* input, vector<VDNPC>* npcs, vector<VDEntity>* objects);
    void Clear();
    void CreateOrLoadTexture(LPDIRECT3DDEVICE9 direct3DDevice);

         HWND GetWindow()                      { return window; }
         HWND GetTransparencyColor()           { return transparencyColor; }
    VDSprite* GetTileSheet()                   { return tileSheet; }
       LPCSTR GetTileSheetImageLocation()      { return tileSheetImageLocation; }
       LPRECT GetTileSheetDimensions()         { return &tileSheetDimensions; }
       LPRECT GetTileSheetSourceRectangle()    { return &tileSheetSourceRectangle; }
       LPCSTR GetSelectedTileImageLocation()   { return selectedTileImageLocation; }
         HWND GetObjectListBox()               { return objectListBox; }
    VDSprite* GetObjectSprite()                { return objectSprite; }
         HWND GetPassableOverTileOption()      { return passableOverTileOption; }
         HWND GetPassableUnderTileOption()     { return passableUnderTileOption; }
         HWND GetImpassableTileOption()        { return impassableTileOption; }
         HWND GetNewAreaTileOption()           { return newAreaTileOption; }
       LPCSTR GetNewAreaFileLocation()         { return newAreaFileLocation; }
         HWND GetNewAreaStartingPointX()       { return newAreaStartingPointX; }
         HWND GetNewAreaStartingPointY()       { return newAreaStartingPointY; }
       LPCSTR GetSelectedObjectImageLocation() { return selectedObjectImageLocation; }
       LPRECT GetObjectSpriteDimensions()      { return &objectSpriteDimensions; }
         HWND GetNullObjectOption()            { return nullObjectOption; }
         HWND GetNPCOption()                   { return npcOption; }
         HWND GetPassableOverObjectOption()    { return passableOverObjectOption; }
         HWND GetPassableUnderObjectOption()   { return passableUnderObjectOption; }
         HWND GetImpassableObjectOption()      { return impassableObjectOption; }
         BOOL IsTileSelected()                 { return tileSelected; }
         void SetTileSelected(BOOL isSelected) { tileSelected = isSelected; }
          int GetSelectedRadioButton()         { return selectedRadioButton; }
private:
         HWND window;
         HWND transparencyColor;
         HWND loadSpriteButton;
    VDSprite* tileSheet;
         char tileSheetImageLocation[FILE_NAME_MAX_SIZE];
         RECT tileSheetDimensions;
         RECT tileSheetSourceRectangle;
         char selectedTileImageLocation[FILE_NAME_MAX_SIZE];
         HWND shiftTileSpriteUp;
         HWND shiftTileSpriteDown;
         HWND shiftTileSpriteLeft;
         HWND shiftTileSpriteRight;
         HWND tileSpawnsListBox;
         HWND creaturesListBox;
         HWND removeSpawnButton;
         HWND addSpawnButton;
         HWND nullTileOption;
         HWND passableOverTileOption;
         HWND passableUnderTileOption;
         HWND impassableTileOption;
         HWND newAreaTileOption;
         HWND loadNewAreaButton;
         HWND newAreaStatic;
         char newAreaFileLocation[FILE_NAME_MAX_SIZE];
         HWND newAreaStartingPointX;
         HWND newAreaStartingPointY;
         HWND objectListBox;
    VDSprite* objectSprite;
         char selectedObjectImageLocation[FILE_NAME_MAX_SIZE];
         char previousObjectSelection[FILE_NAME_MAX_SIZE];
         RECT objectSpriteDimensions;
         HWND previousAnimationButton;
         HWND nextAnimationButton;
         HWND nullObjectOption;
         HWND npcOption;
         HWND passableOverObjectOption;
         HWND passableUnderObjectOption;
         HWND impassableObjectOption;
         BOOL tileSelected;
          int selectedRadioButton;
};



#endif  // VDMAPEDITOR_H