#ifndef VDNPC_H
#define VDNPC_H



/* **********************************************************************************************************************
   Included Header Files
   **********************************************************************************************************************/

#include <vector>
#include "VDEntity.h"
#include "VDDialogue.h"
using namespace std;



/* **********************************************************************************************************************
   VDNPC
   **********************************************************************************************************************/

class VDNPC : public VDEntity {
public:
    VDNPC();
    ~VDNPC();

    VDDialogue* FindDialogue(int id);
           void AddDialogue(int id, LPCSTR text);
           void RemoveDialogue(int id);
           void AddOption(int dialogueID, LPCSTR text, int nextID);
           void RemoveOption(int dialogueID, LPCSTR optionName);
            int RunLogic(double currentTime);
           void WriteToFile(HANDLE anOpenFile);
           void LoadFromFile(HANDLE anOpenFile);

    VDDialogue* GetDialogue(unsigned int index) { return &dialogues.at(index); }
         size_t GetDialoguesSize()              { return dialogues.size(); }
            int GetMovementSpeed()              { return movementSpeed; }
           void SetMovementSpeed(int aSpeed)    { movementSpeed = aSpeed; }
private:
    vector<VDDialogue> dialogues;
                   int movementSpeed;
                double movementTimer;
};



#endif  // VDNPC_H