#ifndef VDNPCEDITOR_H
#define VDNPCEDITOR_H



/* **********************************************************************************************************************
   Included Header Files
   **********************************************************************************************************************/

#include <windows.h>
#include "VDNPC.h"
#include "VDSprite.h"
#include "VDInput.h"
#include "VDError.h"
#include "Resource.h"
using namespace std;



/* **********************************************************************************************************************
   VDNPCEditor
   **********************************************************************************************************************/

class VDNPCEditor {
public:
    VDNPCEditor();
    ~VDNPCEditor();

    void FreeMemory();
    HWND Load(HINSTANCE instance, HWND parentWindow, LPCSTR className);
    void ProcessMessages(LPDIRECT3DDEVICE9 direct3DDevice, VDInput *input, vector<VDNPC>* npcs);
    BOOL AddNPC(vector<VDNPC>* npcs, LPCSTR previousName, LPCSTR name, LPCSTR imageFileLocation, int movementSpeed);
    void WriteNPCs(vector<VDNPC>* npcs);
    void CreateNPCTexture(LPDIRECT3DDEVICE9 direct3DDevice, VDSprite* sprite, LPCSTR npcFileName);

    VDNPC* GetNPC(vector<VDNPC>* npcs, LPCSTR aName);

         HWND GetWindow()                { return window; }
         HWND GetNPCListBox()            { return npcListBox; }
    VDSprite* GetNPCSpriteSheet()        { return npcSpriteSheet; }
    VDSprite* GetNPCSprite()             { return npcSprite; }
       LPRECT GetNPCSpriteDimensions()   { return &npcSpriteDimensions; }
         BOOL GetReloadNPCs()            { return reloadNPCs; }
         void SetReloadNPCs(BOOL reload) { reloadNPCs = reload; }
private:
         HWND window;
         HWND npcListBox;
         char currentNPCSelection[FILE_NAME_MAX_SIZE];
         HWND nameEditBox;
         HWND loadSpriteButton;
    VDSprite* npcSpriteSheet;
         char npcSpriteSheetLocation[FILE_NAME_MAX_SIZE];
         RECT npcSpriteDimensions;
    VDSprite* npcSprite;
         char npcSpriteImageLocation[FILE_NAME_MAX_SIZE];
         HWND shiftNPCUp;
         HWND shiftNPCDown;
         HWND previousAnimation;
         HWND nextAnimation;
         HWND movementSpeedEditBox;
         HWND removeNPCButton;
         HWND newNPCButton;
         HWND saveNPCButton;
         HWND dialogueListBox;
         char currentDialogueSelection[FILE_NAME_MAX_SIZE];
         HWND textEditBox;
         HWND textIDEditBox;
         HWND removeDialogueButton;
         HWND saveDialogueButton;
         HWND optionListBox;
         char currentOptionSelection[FILE_NAME_MAX_SIZE];
         HWND textEditBox2;
         HWND textIDEditBox2;
         HWND removeOptionButton;
         HWND saveOptionButton;
         HWND saveChangesButton;
         BOOL reloadNPCs;
};



#endif  // VDNPCEDITOR_H