#ifndef VDOBJECTEDITOR_H
#define VDOBJECTEDITOR_H



/* **********************************************************************************************************************
   Included Header Files
   **********************************************************************************************************************/

#include <windows.h>
#include <vector>
#include "VDSprite.h"
#include "VDInput.h"
#include "VDEntity.h"
#include "Resource.h"
using namespace std;



/* **********************************************************************************************************************
   VDObjectEditor
   **********************************************************************************************************************/

class VDObjectEditor {
public:
    VDObjectEditor();
    ~VDObjectEditor();

    void FreeMemory();
    HWND Load(HINSTANCE instance, HWND parentWindow, LPCSTR className);
    void ProcessMessages(LPDIRECT3DDEVICE9 direct3DDevice, VDInput* input, vector<VDEntity>* objects);
    void CreateTexture(LPDIRECT3DDEVICE9 direct3DDevice, LPCSTR npcFileName);
    BOOL AddObject(vector<VDEntity>* objects, LPCSTR name, LPCSTR imageFileLocation);
    void WriteObjects(vector<VDEntity>* objects);

    VDEntity* GetVDObject(vector<VDEntity>* objects, LPCSTR name);

         HWND GetObjectListBox()              { return objectListBox; }
    VDSprite* GetObjectSprite()               { return objectSprite; }
       LPRECT GetObjectSpriteDimensions()     { return &objectSpriteDimensions; }
         BOOL IsSpriteSelected()              { return spriteSelected; }
    VDSprite* GetSpriteSheet()                { return spriteSheet; }
       LPRECT GetSpriteSheetDimensions()      { return &spriteSheetDimensions; }
       LPRECT GetSpriteSheetSourceRectangle() { return &spriteSheetSourceRectangle; }
         BOOL GetReloadObjects()              { return reloadObjects; }
         void SetReloadObjects(BOOL reload)   { reloadObjects = reload; }
private:
         HWND window;
         HWND objectListBox;
         char currentObjectSelection[FILE_NAME_MAX_SIZE];
    VDSprite* objectSprite;
         char objectSpriteImageLocation[FILE_NAME_MAX_SIZE];
         RECT objectSpriteDimensions;
         BOOL spriteSelected;
         HWND removeObjectButton;
         HWND loadSpriteButton;
    VDSprite* spriteSheet;
         char spriteSheetImageLocation[FILE_NAME_MAX_SIZE];
         RECT spriteSheetDimensions;
         RECT spriteSheetSourceRectangle;
         char selectedSpriteImageLocation[FILE_NAME_MAX_SIZE];
         HWND shiftSpriteSheetUp;
         HWND shiftSpriteSheetDown;
         HWND shiftSpriteSheetLeft;
         HWND shiftSpriteSheetRight;
         HWND nameEditBox;
         HWND addObjectButton;
         HWND saveChangesButton;
         BOOL reloadObjects;
};



#endif  // VDOBJECTEDITOR_H