#ifndef VDSPRITE_H
#define VDSPRITE_H



/* **********************************************************************************************************************
   Included Header Files
   **********************************************************************************************************************/

#include <d3d9.h>
#include <d3dx9.h>
#include "VDError.h"



/* **********************************************************************************************************************
   VDSprite
   **********************************************************************************************************************/

class VDSprite {
public:
    VDSprite();
    VDSprite(LPDIRECT3DDEVICE9 direct3DDevice, LPCSTR textureFile, RECT sourceRect, D3DXVECTOR3 aPosition, D3DCOLOR colorKey);
    VDSprite(const VDSprite &copySprite);
    virtual ~VDSprite();

    void Draw(LPD3DXSPRITE sprite);
    void ShiftLocation(LPDIRECT3DDEVICE9 direct3DDevice, float x, float y);
    void MovingSprite(int aDirection);
    void FreeTexture();

    LPRECT GetSourceRectangle(LPRECT outRect);
    void SetSourceRectangle(LONG left, LONG top, LONG right, LONG bottom);
    UINT GetSpriteWidth();
    UINT GetSpriteHeight();

    LPDIRECT3DTEXTURE9 GetTexture()                    { return texture; }
           D3DXVECTOR3 GetPosition()                   { return position; }
                  void AddToPosition(float x, float y) { position.x += x; position.y += y; }
                  BOOL IsDead()                        { return isDead; }
                  void KillSprite()                    { isDead = TRUE; }
                   int GetDirection()                  { return direction; }
                  void SetDirection(int aDirection)    { direction = aDirection; }
                  BOOL IsMoving()                      { return isMoving; }
                  void SetIsMoving(BOOL isItMoving)    { isMoving = isItMoving; }
                   int GetMovingDuration()             { return movingDuration; }
                  void SetMovingDuration(int amount)   { movingDuration = amount; }
                  void AddToMovingDuration(int amount) { movingDuration += amount; }
protected:
private:
    LPDIRECT3DTEXTURE9 texture;
                  RECT sourceRectangle;
           D3DXVECTOR3 center;
           D3DXVECTOR3 position;
              D3DCOLOR color;
                  BOOL isDead;
                   int direction;
                  BOOL isMoving;
                   int movingDuration;
};



#endif