/* **********************************************************************************************************************
   Included Header Files
   **********************************************************************************************************************/

#include "VDText.h"



/* **********************************************************************************************************************
   Constructor
   **********************************************************************************************************************/

VDText::VDText() {
    id = -1;
    errno_t returnValue = strcpy_s(text, "");
    if (returnValue != 0) {
        VDError("Failed to initialize the name of the Dialogue text.", __FILE__, __LINE__);
    };
    nextID = -1;
};



/* **********************************************************************************************************************
   Destructor
   **********************************************************************************************************************/

VDText::~VDText() {
};



/* **********************************************************************************************************************
   WriteToFile
   -----------
   Saves the text to hard disk.
   #param  anOpenFile  Handle to a file that's already open.
   **********************************************************************************************************************/

void VDText::WriteToFile(HANDLE anOpenFile) {
    BOOL returnValue = FALSE;
    DWORD numberOfBytesWritten = 0;

    // write the ID
    returnValue = WriteFile(anOpenFile, &id, sizeof(id), &numberOfBytesWritten, NULL);
    if (returnValue == FALSE) {
        VDError("Failed to write dialogue data to file.", __FILE__, __LINE__);
    };

    // write the text
    returnValue = WriteFile(anOpenFile, &text, sizeof(text), &numberOfBytesWritten, NULL);
    if (returnValue == FALSE) {
        VDError("Failed to write dialogue data to file.", __FILE__, __LINE__);
    };

    // write the next ID
    returnValue = WriteFile(anOpenFile, &nextID, sizeof(nextID), &numberOfBytesWritten, NULL);
    if (returnValue == FALSE) {
        VDError("Failed to write dialogue data to file.", __FILE__, __LINE__);
    };
};



/* **********************************************************************************************************************
   LoadFromFile
   ------------
   Loads the text from hard disk.
   #param  anOpenFile  Handle to a file that's already open.
   **********************************************************************************************************************/

void VDText::LoadFromFile(HANDLE anOpenFile) {
    BOOL returnValue = FALSE;
    DWORD numberOfBytesRead = 0;

    // load the ID
    returnValue = ReadFile(anOpenFile, &id, sizeof(id), &numberOfBytesRead, NULL);
    if (returnValue == FALSE) {
        VDError("Failed to read dialogue data.", __FILE__, __LINE__);
    };

    // load the text
    returnValue = ReadFile(anOpenFile, &text, sizeof(text), &numberOfBytesRead, NULL);
    if (returnValue == FALSE) {
        VDError("Failed to read dialogue data.", __FILE__, __LINE__);
    };

    // load the next ID
    returnValue = ReadFile(anOpenFile, &nextID, sizeof(nextID), &numberOfBytesRead, NULL);
    if (returnValue == FALSE) {
        VDError("Failed to read dialogue data.", __FILE__, __LINE__);
    };
};