#ifndef VDWORLD_H
#define VDWORLD_H



/* **********************************************************************************************************************
   Included Header Files
   **********************************************************************************************************************/

#include "VDTile.h"
#include "VDNPC.h"



/* **********************************************************************************************************************
   VDWorld
   **********************************************************************************************************************/

class VDWorld {
public:
    VDWorld();
    ~VDWorld();

    BOOL IsTileInBounds(int locationX, int locationY);
    BOOL IsTileVacant(int entityLocationX, int entityLocationY);
     int ReallocateWorld(int worldMouseLocationX, int worldMouseLocationY);
    void AddObject(BOOL isNPC, LPCSTR name, int locationX, int locationY, LPCSTR imageFileLocation, int movementSpeed, int facingDirection, DWORD colorKey);
    void RemoveObject(int locationX, int locationY);
     int RunNPCLogic(unsigned int index, double currentTime);
    void MoveNPC(unsigned int index, int direction);
    void ClearWorld();
    void WriteWorld(LPCSTR fileName);
    void LoadWorld(LPCSTR fileName);

      VDTile* GetTile(int x, int y) { return &world[x][y]; }
          int GetWorldSizeX() { return worldSizeX; }
          int GetWorldSizeY() { return worldSizeY; }
       VDNPC* GetNPC(unsigned int index) { return &npcs.at(index); }
       size_t GetNPCsSize() { return npcs.size(); }
    VDEntity* GetObject(unsigned int index) { return &objects.at(index); }
       size_t GetObjectsSize() { return objects.size(); }
private:
            VDTile** world;
                 int worldSizeX;
                 int worldSizeY;
       vector<VDNPC> npcs;
    vector<VDEntity> objects;
};



#endif